package node

import (
	"context"
	"net/http"

	"repository.basistech.ru/BASIS/dynamix-golang-sdk/v14/internal/validators"
)

// ApplyIpmiActionRequest struct to apply ipmi action on node
type ApplyIpmiActionRequest struct {
	// Node ID
	// Required: true
	NID uint64 `url:"nid" json:"nid" validate:"required"`

	// Action
	// Available values : is_powered, power_on, shutdown, force_shutdown, reboot.
	// Required: true
	Action string `url:"action" json:"action" validate:"required,action"`
}

// ApplyIpmiAction applies ipmi action on node
func (n Node) ApplyIpmiAction(ctx context.Context, req ApplyIpmiActionRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/node/applyIpmiAction"

	res, err := n.client.DecortApiCall(ctx, http.MethodPost, url, req)
	if err != nil {
		return "", err
	}

	return string(res), nil
}
